﻿define((function () {
    var result = {
        init: function () {
            console.info("init canvas");
        },
        isSupported: function (self) {
            return canvas.getContext != undefined;
        },
        createCanvas: function (self) {
            self.canvas = {
                height: function () {
                    return self.canvas.element.height();
                },
                width: function () {
                    return self.canvas.element.width();
                }
            };
            var h = self.element.height(), w = self.element.width();
            self.canvas.element = $("<canvas></canvas>")
                .attr("height",h)
                .attr("width",w)
                .appendTo(self.element);
            self.canvas.context = self.canvas.element[0].getContext('2d');
            console.info("canvas created");
        },
        clear: function (canvas) {

        },
        types: {
            line: function (canvas, renderer, options) {
                console.info("drawing line");
            },
            image: function (canvas, renderer, options) {
                console.info("drawing image");
            },
            text: function (canvas, renderer, options) {
                console.info("drawing text");
            },
            circle: function (canvas, renderer, options) {
                console.info("drawing cirlce");
            },
            ellipse: function (canvas, renderer, options) {
                console.info("drawing ellipse");
            },
            rectangle: function (canvas, renderer, options) {
                var height = jqgl.utilities.toPixels(canvas.element.height(), options.height);
                var width = jqgl.utilities.toPixels(canvas.element.width(), options.width);
                var x = options.x || 0, y = options.y || 0;
                if (options.fill) {
                    if (options.fill.color)
                        canvas.context.fillStyle = options.fill.color;
                    canvas.context.fillRect(x, y, width, height);
                }

                // stroking is not well supported in html, so we'll draw a line instead.
                if (options.stroke) {
                    canvas.context.lineWidth = options.stroke.width == undefined ? 1 : options.stroke.width;
                    canvas.context.strokeStyle = options.stroke.color == undefined ? "black" : options.stroke.color;
                    canvas.context.beginPath(x, y);
                    canvas.context.lineTo(x + width, y);
                    canvas.context.lineTo(x + width, y + height);
                    canvas.context.lineTo(x, y + height);
                    canvas.context.lineTo(x, y);
                    canvas.context.closePath();
                    canvas.context.stroke();
                }
                console.warn("do rectangle stroking");
                console.warn("do rectangle rounding");
            },
            polygon: function (canvas, renderer, options) {
                console.info("drawing polygon");
            },
            path: function (canvas, renderer, options) {
                console.info("drawing path");
            }
        }
    };
    return result;
})());
//    fillRect: function (canvas,x, y, h, w) {
//        canvas.context.fillRect(x, y, h, w);
//    },
//    fillStyle : function(canvas,style) {
//        canvas.context.fillStyle = style;
//    },
//    strokeRect: function (canvas, x, y, h, w) {
//        canvas.context.strokeRect(x, y, h, w);
//    },
//    strokeStyle : function(canvas,style) {
//        canvas.context.strokeStyle = style;
//    },