﻿define((function () {
    jqgl.utilities.registerNamespace("jqgl.renderers");
    jqgl.renderers.svg = function (container) {
        this.container = container;
        this.document = container.element[0].ownerDocument;
    };
    jqgl.renderers.svg.prototype =
    {
        ns: "http://www.w3.org/2000/svg",
        xlinkns: "http://www.w3.org/1999/xlink",
        createElement: function (parent, name, attributes) {
            var element = this.document.createElementNS(this.ns, name);
            for (var n in attributes) {
                var v = attributes[n];
                if (v != undefined && v != null && (typeof v != 'string' || v != ''))
                    element.setAttribute(n, v);
            }
            parent.appendChild(element);
            return element;
        },
        height: function () {
            return this.container.element.height();
        },
        width: function () {
            return this.container.element.width();
        }
    };
    var result = {
        init: function () {
            console.info("svg - init canvas");
        },
        createCanvas: function (container) {
            var canvas = container.canvas = new jqgl.renderers.svg(container);
            //try {
            canvas.svgElement = canvas.createElement(container.element[0], "svg", {
                'version': '1.1',
                'width': canvas.width(),
                'height': canvas.height()
            });
            // }
            //            catch (e) {
            //                if ($.browser.msie) {
            //                    if (!container.id) {
            //                        container.id = 'svg' + (this._uuid++);
            //                    }
            //                    this._settings[container.id] = settings;
            //                    container.innerHTML = '<embed type="image/svg+xml" width="100%" ' +
            //					'height="100%" src="' + (settings.initPath || '') + 'blank.svg" ' +
            //					'pluginspage="http://www.adobe.com/svg/viewer/install/main.html"/>';
            //                }
            //                else {
            //                    container.innerHTML = '<p class="svg_error">' +
            //					this.local.notSupportedText + '</p>';
            //                }
            //            }

            console.info("svg - canvas created");
        },
        clear: function (canvas) {

        },
        types: {
            line: function (canvas, renderer, options) {
                console.info("svg - drawing line");
            },
            image: function (canvas, renderer, options) {
                console.info("svg - drawing image");
            },
            text: function (canvas, renderer, options) {
                console.info("svg - drawing text");
            },
            circle: function (canvas, renderer, options) {
                console.info("svg - drawing cirlce");
            },
            ellipse: function (canvas, renderer, options) {
                console.info("svg - drawing ellipse");
            },
            rectangle: function (canvas, renderer, options) {
                var height = jqgl.utilities.toPixels(canvas.height(), options.height);
                var width = jqgl.utilities.toPixels(canvas.width(), options.width);
                var rect = canvas.createElement(canvas.svgElement, "rect",
                    {
                        "x": options.x || 0,
                        "y": options.y || 0,
                        "width": width,
                        "height": height
                    });

                if (options.fill && options.fill.color)
                    rect.setAttribute("fill", options.fill.color);

                if (options.stroke) {
                    if (options.stroke.color)
                        rect.setAttribute("stroke", options.stroke.color);
                    if (options.stroke.width)
                        rect.setAttribute("stroke-width", options.stroke.width);
                    console.warn("svg - must do stroke position");
                }
                console.warn("do rectangle rounding");
            },
            polygon: function (canvas, renderer, options) {
                console.info("svg - drawing polygon");
            },
            path: function (canvas, renderer, options) {
                console.info("svg - drawing path");
            }
        },
        methods: {

        }
    };
    return result;
})());
//    fillRect: function (canvas,x, y, h, w) {
//        canvas.context.fillRect(x, y, h, w);
//    },
//    fillStyle : function(canvas,style) {
//        canvas.context.fillStyle = style;
//    },
//    strokeRect: function (canvas, x, y, h, w) {
//        canvas.context.strokeRect(x, y, h, w);
//    },
//    strokeStyle : function(canvas,style) {
//        canvas.context.strokeStyle = style;
//    },